#ifndef _LCD_H
#define _LCD_H

#include"reg52.h"
#include"intrins.h"
#include"TheCustomData.h"
#define uchar unsigned char
#define uint  unsigned int		
#define LCD_databus P3	
sbit RS=P1^6;
sbit RW=P1^5;
sbit EN=P1^4;
void delay_lcd(unsigned int t)
{
	unsigned int i,j;
	for(i=0; i<t;  i++)
    for(j=0; j<10; j++);
}
void Read_busy()	//LCD12864æ 
{
	RS=0;
	RW=1;
	EN=1;
	LCD_databus=0xFF;
	while(LCD_databus & 0x80);	//жλ1---busy0---Nobusy 
	EN=0;
}
void delay(uint i)	//ʱ 
{
	while(--i);
}
void write_LCD_command(uchar value)//дָ 
{
	RS=0;
	RW=0;
	EN=1;
	LCD_databus=value;
	delay(7);
	EN=0;
}
void write_LCD_data(uchar value)//д 
{
	RS=1;
	RW=0;
	EN=1;
	LCD_databus=value;
	delay(7);
	EN=0;
}
void Clear_GDRAM()		//GDRAM 
{
	uchar x,y;
	for(y=0;y<64;y++)
	{
		for(x=0;x<16;x++)
		{
			write_LCD_command(0x34);
			write_LCD_command(y+0x80);	//ʹֱַ 
			write_LCD_command(x+0x80);	//ˮƽַ 
			write_LCD_command(0x30);	//ָ 
			write_LCD_data(0x00);		//д0 
			write_LCD_data(0x00);
		}
	}
}
uchar ReadByte()	//LCD 
{
	uchar Read_value;
	Read_busy();
	RS=1;
	RW=1;
	EN=0;
	EN=1;
	Read_value=LCD_databus;	
	EN=0;
	
	return Read_value;
}

void display_BMP(uchar *address)//ʾͼƬ 
{
	uchar i,j;
	for(i=16;i<32;i++)
	{
		write_LCD_command(0x80+i);	//ʹֱַ 
		write_LCD_command(0x80);	//ˮƽַ 
		for(j=0;j<16;j++)
		{
			write_LCD_data(*address);//д 
			address++;
		}
	}
	
	for(i=0;i<32;i++)
	{
		write_LCD_command(0x80+i);//ʹֱַ 
		write_LCD_command(0x88);	//ˮƽַ
		for(j=0;j<16;j++)
		{
			write_LCD_data(*address);
			address++;
		}
	}
	
}

void Draw_histo(uchar x,uchar y,uchar color)
{
	uchar ROW,xlabel,xlabel_bit;
	uchar Read_H,Read_L; 		//LCDе
	write_LCD_command(0x34);	//ָ
	write_LCD_command(0x36);	//򿪻ͼָ
	xlabel=x>>4;				//ȡ16*16׵ַ
	xlabel_bit=x & 0x0F;		//õ16λݵĵڼλ	
	if(y<32)					//ϰ,°y0--31
	{
		ROW=y;
	}
	else						//ʾ°
	{
		ROW=y-32;
		xlabel+=8;			   //涨ʾ°
	}
	write_LCD_command(ROW+0x80); //봹ֱַ
	write_LCD_command(xlabel+0x80);//ˮƽַ
	ReadByte();	//ȡǰGDRAMǰһοնͿԶ 
	Read_H=ReadByte(); //8λ
	Read_L=ReadByte(); //8λ
	
	write_LCD_command(ROW+0x80); 	//봹ֱַ
	write_LCD_command(xlabel+0x80);	//ˮƽַ
	
	if(xlabel_bit<8)
	{
		switch(color)
		{
			case 0:Read_H &= (~(0x01<<(7-xlabel_bit)));// 
			break;
			case 1:Read_H |= (0x01<<(7-xlabel_bit));//Ϳ 
			break;
			case 2:Read_H ^= (0x01<<(7-xlabel_bit));//ת 
			break;	
			default:break;
		}
		write_LCD_data(Read_H);//дGDRAM 
		write_LCD_data(Read_L);//дλдλ(ַָ˳) 
	}
	else
	{
		switch(color)//color 
		{
			case 0: Read_L &= (~(0x01<<(15-xlabel_bit)));// 
			break;
			case 1: Read_L |= (0x01<<(15-xlabel_bit));//Ϳ 
			break;
			case 2: Read_L ^= (0x01<<(15-xlabel_bit));//ת 
			break;
			default:break;
		}
		write_LCD_data(Read_H);
		write_LCD_data(Read_L);//д 
	}
	
	write_LCD_command(0x30);//صͨģʽ 
}

void init_LCD()	//LCD12864ʼ 
{
	delay(4000);
	write_LCD_command(0x30);//8λݸʽָʾ 
	delay(100);				//ʱʱ 
	write_LCD_command(0x30);//8λݸʽָʾ 
	delay(37);
	write_LCD_command(0x0C);//ʾرչ 
	delay(100);
	write_LCD_command(0x01);//ָ 
	delay(10000);			//ʱ 
	write_LCD_command(0x06);//ʾ㣺ָԼ1 
}
void hzkdis(unsigned char code *s)
{  
	while(*s > 0)
    { 
		write_LCD_data(*s);
		s++;
		delay_lcd(50);
    }
}




void writeString(uchar row,uchar rank,unsigned char *s)
{
  uchar addr;
  switch(row)
  {
    case 0:addr=0x80;break;
    case 1:addr=0x90;break;
    case 2:addr=0x88;break;
    case 3:addr=0x98;break;
  }
  write_LCD_command(addr+rank);
  hzkdis(s);
}

void writeNumber(uchar row,uchar rank,unsigned int s)
{
  uchar addr;
  switch(row)
  {
    case 0:addr=0x80;break;
    case 1:addr=0x90;break;
    case 2:addr=0x88;break;
    case 3:addr=0x98;break;
  }
  write_LCD_command(addr+rank);
  write_LCD_data(s/10000%10+0x30);
  write_LCD_data(s/1000%10+0x30);
  write_LCD_data(s/100%10+0x30);
  write_LCD_data(s/10%10+0x30);
  write_LCD_data(s%10+0x30);
}
#endif